import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.net.*;


public class jVisInfoWindow extends JFrame {
    private JButton okay;
    private JPanel buttonPanel;
    private JEditorPane gpl;
    private JEditorPane license;
    private JScrollPane gplscrollPane;
    
public jVisInfoWindow() {

    super(jVisualizer.programmtitel + ", Info");
    setDefaultCloseOperation(HIDE_ON_CLOSE);	

    try{ license = new JEditorPane(getClass().getResource("license.html")); }
    catch(Exception e){ license = new JEditorPane("text/plain", "Error reading license.html"); }
    license.setEditable(false);

    try{ gpl = new JEditorPane(getClass().getResource("gpl.html")); }
    catch(Exception e){ gpl = new JEditorPane("text/plain", "Error reading gpl.html"); }
    gpl.setEditable(false);
    gplscrollPane = new JScrollPane(gpl,JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
                                        JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
    
    okay = new JButton("OK");
    okay.addActionListener( new ActionListener(){
        public void actionPerformed(ActionEvent ae){
            setVisible(false);
        }
    });
    buttonPanel = new JPanel();
    buttonPanel.add(okay);

    getContentPane().add(license,"North");
    getContentPane().add(gplscrollPane,"Center");
    getContentPane().add(buttonPanel,"South");

    display();
}


public void display(){
    setSize( 600,500 );
    setLocation( 50,00 );
    setVisible(true);
    toFront();
} 


} //class