import java.util.*;

public class jVisSpektrumEntity {

    private String kopplungsmuster;
    private String kopplungskonstanten;
    private Vector peakVector;
    private int peakAnz;

		

public jVisSpektrumEntity(){

    kopplungsmuster = "s";
    kopplungskonstanten = "0";    
    peakVector = new Vector();
    peakVector.addElement(new jVisPeakEntity());
    peakAnz = 1;
}
	

public jVisSpektrumEntity(jVisSpektrumEntity input, String sdtq, int j){
    
    int sdtqCounter = 0;
    
    if      (sdtq == "d"){ sdtqCounter = 1; }
    else if (sdtq == "t"){ sdtqCounter = 2; }
    else if (sdtq == "q"){ sdtqCounter = 3; };

    if ( sdtqCounter != 0 && j != 0 ){
        if (input.kopplungsmuster == "s" && input.kopplungskonstanten == "0"){
            kopplungsmuster = sdtq;
            kopplungskonstanten = "" + j;
        }
        else{
            kopplungsmuster = input.kopplungsmuster + sdtq;
            kopplungskonstanten = input.kopplungskonstanten + ", " + j;
        };
    }
    else{
        kopplungsmuster = input.kopplungsmuster;
        kopplungskonstanten = input.kopplungskonstanten;    
    };
    

    
    
    Vector h1, h2;
    h1 = input.peakVector;
    h2 = input.peakVector;

    while (sdtqCounter > 0 && j != 0){
        sdtqCounter--;

        h2 = new Vector();

        //erstes Element uebertragen
        h2.addElement( new jVisPeakEntity( (jVisPeakEntity)h1.elementAt(0), j*(-1)  ) );
        h2.addElement( new jVisPeakEntity( (jVisPeakEntity)h1.elementAt(0), j       ) );
            
        for (int i = 1; i < h1.size(); i++){
        //i zeigt auf das gerade einzufuegende jVisPeakEntity-Element von h1
            boolean minusFertig = false;  // (-1)*j noch nicht eingefuegt
            boolean plusFertig = false;   //      j noch nicht eingefuegt

            int k = 0;
            //k zeigt auf die zu pruefende Einfuegeposition in h2
            while( !minusFertig || !plusFertig ){
                if( !minusFertig ){
                    if( ((jVisPeakEntity)h1.elementAt(i)).getVerschiebung() - j < ((jVisPeakEntity)h2.elementAt(k)).getVerschiebung() ){
                        h2.insertElementAt(new jVisPeakEntity( (jVisPeakEntity)h1.elementAt(i), j*(-1) ) ,k);
                        minusFertig = true;
                    }
                    else if ( ((jVisPeakEntity)h1.elementAt(i)).getVerschiebung() - j == ((jVisPeakEntity)h2.elementAt(k)).getVerschiebung() ){
                        ((jVisPeakEntity)h2.elementAt(k)).addKennungen( (jVisPeakEntity)h1.elementAt(i), j*(-1) );
                        minusFertig = true;
                    }
                    else if (k + 1 == h2.size()){
                        h2.addElement(new jVisPeakEntity( (jVisPeakEntity)h1.elementAt(i), j*(-1) ) );
                        minusFertig = true;
                    }
                }
                if( !plusFertig ){
                    if( ((jVisPeakEntity)h1.elementAt(i)).getVerschiebung() + j < ((jVisPeakEntity)h2.elementAt(k)).getVerschiebung() ){
                        h2.insertElementAt(new jVisPeakEntity( (jVisPeakEntity)h1.elementAt(i), j ) ,k);
                        plusFertig = true;
                    }
                    else if ( ((jVisPeakEntity)h1.elementAt(i)).getVerschiebung() + j == ((jVisPeakEntity)h2.elementAt(k)).getVerschiebung() ){
                        ((jVisPeakEntity)h2.elementAt(k)).addKennungen( (jVisPeakEntity)h1.elementAt(i), j );
                        plusFertig = true;
                    }
                    else if (k+1 == h2.size()){
                        h2.addElement(new jVisPeakEntity( (jVisPeakEntity)h1.elementAt(i), j ) );
                        plusFertig = true;
                    }
                }
                k++;
            } // while k

        } // for i

        h1 = h2;

    } // while sdtqCounter > 0 && j > 0
    peakVector = h2;
    peakAnz = peakVector.size();
    
}


public String toString(){
    String tmp = "jVisSpektrumEntity to String()-Methode";
    tmp = tmp + "\n  " + peakAnz + " Signale durch    " + kopplungsmuster + "   " + kopplungskonstanten;
    tmp = tmp + "\n  Hhe  Verschiebung  Kennungen";
    for (int i = 0; i < peakAnz; i++){
        tmp = tmp + "\n  " + "   " + ((jVisPeakEntity)peakVector.elementAt(i)).getAnzKennungen() + 
                    "    " + ((jVisPeakEntity)peakVector.elementAt(i)).getVerschiebung() + 
                    "    " + ((jVisPeakEntity)peakVector.elementAt(i)).getKennungen();
    };
    return tmp;
} 


public int getAnzPeaks(){
    return peakAnz;
}


public jVisPeakEntity getPeak(int index){
    return (jVisPeakEntity) peakVector.elementAt(index);
}


public String getKopplungskonstanten(){
    return kopplungskonstanten;
}


public String getKopplungsmuster(){
    return kopplungsmuster;
}


} // class
