import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class jVisWindow extends JFrame{

	private JPanel scrollPanel;
	private JScrollPane scrollPane;
	private JButton beenden;
	private JButton info;
	private JPanel buttonPanel;

public jVisWindow(){

	super(jVisualizer.programmtitel);
	setSize( 700,570 );
	setLocation( 0,0 );	
        
        addWindowListener( new WindowAdapter(){
            public void windowClosing(WindowEvent we){
                jVisualizer.quit();
            }
        });
        
	beenden = new JButton("Quit");
        beenden.addActionListener( new ActionListener(){
            public void actionPerformed(ActionEvent ae){
                jVisualizer.quit();
            }
        });
//	beenden.setToolTipText("Quit");

	info = new JButton("Info...");
        info.addActionListener( new ActionListener(){
            public void actionPerformed(ActionEvent ae){
                jVisualizer.info();
            }
        });
//	info.setToolTipText("Info");

	buttonPanel = new JPanel();
	buttonPanel.add(beenden);
	buttonPanel.add(info);

	scrollPanel = new JPanel();
	scrollPanel.setLayout( new BoxLayout(scrollPanel,BoxLayout.Y_AXIS) );
	scrollPane = new JScrollPane(scrollPanel,JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
                                    JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);

        //mehrere jVisSpektrumController initialisieren und
        jVisSpektrumController w1 = new jVisSpektrumController();
        jVisSpektrumController w2 = new jVisSpektrumController(w1);
        jVisSpektrumController w3 = new jVisSpektrumController(w2);       
        jVisSpektrumController w4 = new jVisSpektrumController(w3);       
        jVisSpektrumController w5 = new jVisSpektrumController(w4);       

        //zur scrollPanel hinzufuegen
        scrollPanel.add(w1);
        scrollPanel.add(w2);
        scrollPanel.add(w3);
        scrollPanel.add(w4);
        scrollPanel.add(w5);

	getContentPane().add(scrollPane, "Center");
	getContentPane().add(buttonPanel, "South");

	setVisible(true);
	
} // constructor jVisWindow()

}
