import java.util.*;

public class jVisPeakEntity {
	private int verschiebung;
	private Vector kennungen = new Vector();

public jVisPeakEntity(){
    verschiebung = 0;
        kennungen.addElement(new String());
}


public jVisPeakEntity(jVisPeakEntity wp, int j){
    // j entspricht der Kopplungskonstanten

    // bei j < 0 verschiebung = p.verschiebung - j
    // und anhaengen von "1" an alle kennungen
    // bei j > 0 verschiebung = p.verschiebung + j
    // und anhaengen von "2" an alle kennungen

    if (j > 0){  // PLUS
        verschiebung = wp.getVerschiebung() + j;
        for (int i = 0; i < wp.getAnzKennungen() ; i++){
            kennungen.addElement(  wp.getKennung(i) + "2" );
        };
    }
    else if (j < 0){    // MINUS
        verschiebung = wp.getVerschiebung() + j;
        for (int i = 0; i < wp.getAnzKennungen() ; i++){
            kennungen.addElement( wp.getKennung(i) + "1" );
        };
    }
    else{             // j = 0
        verschiebung = wp.getVerschiebung();
        for (int i = 0; i < wp.getAnzKennungen() ; i++){
            kennungen.addElement( wp.getKennung(i) + "0" );
        };
    };     
}


public void addKennungen(jVisPeakEntity wp, int j){
    if (j > 0){  // PLUS
        for (int i = 0; i < wp.getAnzKennungen() ; i++){
            kennungen.addElement(  wp.getKennung(i) + "2" );
        };
    }
    else if (j < 0){    // MINUS
        for (int i = 0; i < wp.getAnzKennungen() ; i++){
            kennungen.addElement(  wp.getKennung(i) + "1" );
        };
    }
    else {    // j = 0
        for (int i = 0; i < wp.getAnzKennungen() ; i++){
            kennungen.addElement(  wp.getKennung(i) + "0" );
        };
    };
}


public boolean equals(String kennung){
    // Durch dieses Ueberladen der equals-Methode von Object
    // ist es moeglich, durch contains(String) auf einer
    // ArrayList von Peak-Objekten
    // nach einem Peak-Objekt mit bestimmter kennung in
    // seiner Kennungs-ArrayList zu suchen
    return kennungen.contains(kennung);
}


public boolean equals(Integer i){
    // Durch dieses Ueberladen der equals-Methode von Object
    // ist es moeglich, durch contains(Integer) auf einer
    // ArrayList von Peak-Objekten 
    // nach einem Peak-Objekt mit bestimmtem verschiebung
    // zu suchen
    return verschiebung == i.intValue();
}


public int getVerschiebung(){
    return verschiebung;
}


public int getKennungslaenge(){
    return ((String)kennungen.elementAt(0)).length();
}


public String getKennungen(){
    String temp = (String)kennungen.elementAt(0);
    for (int i = 1; i < kennungen.size(); i++){
        temp += ("," + (String)kennungen.elementAt(i) ) ;
    }
    return temp;
}


public int getAnzKennungen(){
    //Zusammen mit getKennung(int index) ermglicht diese Methode das Iterieren 
    //ueber alle kennungen
    return kennungen.size();
}


public String getKennung(int index){
    //Zusammen mit der Methode getAnzKennungen() ermglicht diese Methode das Iterieren 
    //ueber alle kennungen
    return (String)kennungen.elementAt(index);
}


}  // class
