import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;


public class jVisSpektrumController extends JPanel {

    private jVisSpektrumViewPanel myjVisSpektrumViewPanel;
    private jVisSpektrumModelPanel myjVisSpektrumModelPanel;
    private jVisSpektrumEntity inputjVisSpektrumEntity;
    private jVisSpektrumEntity outputjVisSpektrumEntity;
    private jVisSpektrumController beobachter;

        
public jVisSpektrumController(){

    inputjVisSpektrumEntity = new jVisSpektrumEntity();
    outputjVisSpektrumEntity = new jVisSpektrumEntity(inputjVisSpektrumEntity, "d", 0);

    myjVisSpektrumViewPanel = new jVisSpektrumViewPanel(outputjVisSpektrumEntity);
    myjVisSpektrumModelPanel = new jVisSpektrumModelPanel(this);
    
    add(myjVisSpektrumViewPanel);
    add(myjVisSpektrumModelPanel);
    
    //this.setBorder(BorderFactory.createTitledBorder("Kopplungseinheit"));
    this.setBorder(BorderFactory.createEtchedBorder());
}


public jVisSpektrumController(jVisSpektrumController inputjVisSpektrumController){

    inputjVisSpektrumController.beobachter = this;
    
    inputjVisSpektrumEntity = inputjVisSpektrumController.outputjVisSpektrumEntity;
    outputjVisSpektrumEntity = new jVisSpektrumEntity(inputjVisSpektrumEntity, "d", 0);

    myjVisSpektrumViewPanel = new jVisSpektrumViewPanel(outputjVisSpektrumEntity);
    myjVisSpektrumModelPanel = new jVisSpektrumModelPanel(this);
    
    add(myjVisSpektrumViewPanel);
    add(myjVisSpektrumModelPanel);
    this.setBorder(BorderFactory.createEtchedBorder());
}


public void setKopplung(String sdtq, int kopplungskonstante){
    outputjVisSpektrumEntity = new jVisSpektrumEntity(inputjVisSpektrumEntity, sdtq, kopplungskonstante);
    if (beobachter != null) beobachter.setInputspektrum(outputjVisSpektrumEntity);
    myjVisSpektrumViewPanel.setjVisSpektrumEntity(outputjVisSpektrumEntity);
}


public void setInputspektrum(jVisSpektrumEntity newInputspektrum){
    inputjVisSpektrumEntity = newInputspektrum;
    myjVisSpektrumModelPanel.getKopplung();

}


public void newjVisCalculateWindow(){
    jVisualizer.newjVisCalculateWindow(outputjVisSpektrumEntity);
    
}


}
