import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class jVisSpektrumModelPanel extends JPanel{

    private jVisSpektrumController	beobachter;
    private JRadioButton		dublett, triplett, quartett;
    private String			sdtq;
    private JSlider 			kopplungskonstanteSlider;
    private int				kopplungskonstante;
    private JButton			calculate;


public jVisSpektrumModelPanel(jVisSpektrumController ajVisSpektrumController){

    beobachter = ajVisSpektrumController;
    
    dublett = new JRadioButton("d");
    dublett.setSelected(true);
    sdtq = "d";
    dublett.addActionListener( new ActionListener(){
        public void actionPerformed(ActionEvent ae){
           sdtq = "d";
           beobachter.setKopplung(sdtq, kopplungskonstante);
        }
    });
    triplett = new JRadioButton("t");
    triplett.addActionListener( new ActionListener(){
        public void actionPerformed(ActionEvent ae){
           sdtq = "t";
           beobachter.setKopplung(sdtq, kopplungskonstante);
        }
    });
    quartett = new JRadioButton("q");
    quartett.addActionListener( new ActionListener(){
        public void actionPerformed(ActionEvent ae){
           sdtq = "q";
           beobachter.setKopplung(sdtq, kopplungskonstante);
        }
    });
    
    ButtonGroup kopplungsmuster = new ButtonGroup();
    kopplungsmuster.add(dublett);
    kopplungsmuster.add(triplett);
    kopplungsmuster.add(quartett);
    JPanel kopplungsmusterPanel = new JPanel();
    kopplungsmusterPanel.add(dublett);
    kopplungsmusterPanel.add(triplett);
    kopplungsmusterPanel.add(quartett);
    
    kopplungskonstanteSlider = new JSlider(JSlider.HORIZONTAL,0,50,0);
    kopplungskonstanteSlider.setMajorTickSpacing(10);
    kopplungskonstanteSlider.setMinorTickSpacing(5);
    kopplungskonstanteSlider.setExtent(1);
    kopplungskonstanteSlider.setPaintTicks(true);
    kopplungskonstanteSlider.setPaintLabels(true);
    Hashtable kopplungskonstanteLabelTable = new Hashtable();
    kopplungskonstanteLabelTable.put(new Integer(0), new JLabel("0"));
    //kopplungskonstanteLabelTable.put(new Integer(25), new JLabel("[units]"));
    kopplungskonstanteLabelTable.put(new Integer(49), new JLabel("max")); 
    kopplungskonstanteSlider.setLabelTable(kopplungskonstanteLabelTable);
    kopplungskonstanteSlider.addChangeListener( new ChangeListener(){
        public void stateChanged(ChangeEvent e) {
            if (kopplungskonstante != kopplungskonstanteSlider.getValue()){
                kopplungskonstante = kopplungskonstanteSlider.getValue();
                beobachter.setKopplung(sdtq, kopplungskonstante);
            }
        } 
    });
    //kopplungskonstanteSlider.setToolTipText("J");

    calculate = new JButton("Calculate...");
    calculate.addActionListener( new ActionListener(){
        public void actionPerformed(ActionEvent ae){
           beobachter.newjVisCalculateWindow();
        }
    });
    //calculate.setToolTipText("Calculate");
    JPanel calculatePanel = new JPanel();
    calculatePanel.add(calculate);

    setLayout(new BorderLayout());
    add(kopplungskonstanteSlider,"North");
    add(kopplungsmusterPanel,"Center");
    add(calculatePanel,"South");


} // Kontruktor jVisSpektrumModelPanel()


public void getKopplung(){
    beobachter.setKopplung(sdtq, kopplungskonstante);
}



}